package oracle.jheadstart.controller.jsf.bean;

import java.sql.ResultSet;
import java.sql.SQLException;

import java.util.Iterator;
import java.util.Map;

import javax.faces.component.UIComponent;
import javax.faces.component.ValueHolder;
import javax.faces.context.FacesContext;
import javax.faces.el.ValueBinding;


import oracle.adf.view.faces.component.UIXEditableValue;

import oracle.adf.view.faces.model.RowKeySet;

import oracle.jbo.Key;
import oracle.jbo.Row;
import oracle.jbo.ViewObject;
import oracle.jbo.uicli.binding.JUCtrlValueBinding;

import oracle.jbo.uicli.binding.JUIteratorBinding;

import oracle.jheadstart.controller.jsf.util.JsfUtils;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class ExtendedLovItemBean extends LovItemBean {
    private static Log sLog = LogFactory.getLog(ExtendedLovItemBean.class);

    private String nestedRecordAttributeMapping;

    public ExtendedLovItemBean() {
    }

    private void processResultSet(ResultSet rs) {
        // Fetch each row from the result set
        ViewObject vo = 
            getLovPage().getIterBinding().getRowSetIterator().getRowSet().getViewObject();
        try {
            while (rs.next()) {
                System.out.println(nestedRecordAttributeMapping);
                    String patternStr = ",";
                    String[] mappings = nestedRecordAttributeMapping.split(patternStr);
                    Row newRow = getTableCollectionModel().createNewRow(true);
                    for (int i=0;i<mappings.length;i++) {
                        System.out.println(mappings[i]);
                        String[] sourceTarget = mappings[i].split("=");
                        newRow.setAttribute(sourceTarget[1], rs.getObject(sourceTarget[0]));                                            
                    }
//                Object  value = rs.getObject("employee_id");
                //newRow.setAttribute("EmpId", rs.getObject("employee_id"));
                //newRow.setAttribute("Id", rs.getObject("employee_id"));
            }
        } catch (SQLException e) {
            // TODO
        }
        // We need to reset table component tree, because otherwise some of the items
        // set on the newly created row are not immediately visible in the page when
        // returning from the LOV (bug??)
        getTableCollectionModel().refresh();
        JsfUtils.getInstance().resetComponentTree(getTableCollectionModel().getTable());
    }

    public void copyReturnValues(Map selectedRowData, Row lovRow, 
                                 Object baseRow, boolean copyToUI, 
                                 boolean commaSeparated) {
        // first clear any dependent items, if they exist
        clearDependentItems();
        UIComponent parent = getLovField().getParent();
        Iterator keys = getReturnValues().keySet().iterator();
        while (keys.hasNext()) {
            String lovItem = (String)keys.next();
            String baseItem = (String)getReturnValues().get(lovItem);
            Object value = 
                lovRow != null ? lovRow.getAttribute(lovItem) : selectedRowData.get(lovItem);
            if (value instanceof ResultSet) {
                // do not process this key/item any further
                continue;
            }

            // we first get the underlying binding and check for updateability. We do this
            // regardless of value of copyToModel because when the underlying binding is
            // read only, we can NEVER update the UI Component, as this results in an error
            // when JSF performs the update model phase. Exception is the LOV attribute itself because
            // this is not bound to an ADFm binding but to the lovFieldValue property in this bean.
            boolean isUpdateable = true;
            // lov FieldBinding is null when used in search region!
            JUCtrlValueBinding binding = null;
            if (getLovFieldBinding() != null) {
                binding = 
                        (JUCtrlValueBinding)getLovFieldBinding().getBindingContainer().findCtrlBinding(baseItem);
                if (binding != null) {
                    String attribute = binding.getAttributeDef().getName();
                    // if tableCollectionModel is set, the LOV is used in a table, and we must 
                    // copy to the "current" row in the table, otherwise we can copy to the bindinh itself
                    if (baseRow instanceof Row) {
                        Row currow = (Row)baseRow;
                        isUpdateable = 
                                currow.isAttributeUpdateable(currow.getAttributeIndexOf(attribute));
                        if (isCopyToModel()) {
                            if (isUpdateable) {
                                currow.setAttribute(attribute, value);
                                sLog.debug("Copied LOV value " + value + 
                                           " to attribute " + attribute + 
                                           " in row with key " + 
                                           currow.getKey());
                            } else {
                                sLog.debug("Attribute " + attribute + 
                                           " in row with key " + 
                                           currow.getKey() + 
                                           " is read-only, cannot copy LOV value");
                            }
                        }
                    } else if (baseRow instanceof NewTableRowBean) {
                        isUpdateable = true;
                        NewTableRowBean newrow = (NewTableRowBean)baseRow;
                        newrow.put(attribute, value);
                        sLog.debug("Copied LOV value " + value + 
                                   " to attribute " + attribute + 
                                   " in new table row with index " + 
                                   getTableCollectionModel().getRowIndex());
                    } else {
                        isUpdateable = binding.isUpdateable();
                        if (isCopyToModel()) {
                            if (isUpdateable && isCopyToModel()) {
                                binding.setInputValue(value);
                                sLog.debug("Copied LOV value " + value + 
                                           " to binding " + binding.getName());
                            } else {
                                sLog.debug("ADFm binding " + 
                                           binding.getName() + 
                                           " is read-only, cannot copy LOV value");
                            }
                        }
                    }
                } else {
                    sLog.debug("No ADFm binding found with name " + baseItem + 
                               ", cannot copy LOV value");
                }
            }


            UIComponent component = parent.findComponent(baseItem);
            if (!copyToUI) {
                // do nothing
            } else if (component != null && component instanceof ValueHolder) {
                // When using ADF Faces we must call resetValue first to see 
                // the new values in the UI. resetValue does not exist on generic
                // JSF EditableValueHolder interface, which is strange. 
                // TODO: find out what happens with NON-ADf Faces components 
                if (component instanceof UIXEditableValue) {
                    ((UIXEditableValue)component).resetValue();
                } else {
                    sLog.debug("Cannot execute resetValue on UIComponent " + 
                               component.getId() + 
                               ", does not implement UIXEditableValue interface");
                }
                //        if (!isUpdateable && component != getLovField())
                if (!isUpdateable) {
                    sLog.debug("Underlying ADFm binding " + binding.getName() + 
                               " of UIComponent " + component.getId() + 
                               " is read-only, LOV value not copied to UI Component. ADF BC should ensure you still see the value in your page. If this is not the case, read the JHeadstart Developer's guide, chapter 3, section 'Defining an LOV on a display item'.");
                } else {
                    if (commaSeparated) {
                        value = 
                                ((ValueHolder)component).getValue() != null ? ((ValueHolder)component).getValue() + 
                                "," + value : value;
                    }
                    ((ValueHolder)component).setValue(value);
                    sLog.debug("Copied LOV value " + value + 
                               " to UIComponent " + component.getId());

                    // if underlying value binding is updateable, we always copy the value
                    // to this value binding too. This is currently redundant for table and form
                    // items, but not for search items!
                    ValueBinding vb = component.getValueBinding("value");
                    if (vb != null && 
                        !vb.isReadOnly(FacesContext.getCurrentInstance())) {
                        sLog.debug("Copying value " + value + 
                                   " to value binding " + 
                                   vb.getExpressionString() + 
                                   " of UIComponent " + component.getId());
                        vb.setValue(JsfUtils.getFacesContext(), value);
                    }
                }
            } else {
                if (component == null) {
                    sLog.debug("No UI Component found with name " + baseItem + 
                               ", cannot copy LOV value");
                } else {
                    sLog.debug("UI Component " + baseItem + 
                               " does not implement ValueHolder interface, cannot copy LOV value");
                }
            }
        }
    }

    public void copyNestedReturnValues(Row lovRow) {
        Iterator keys = getReturnValues().keySet().iterator();
        while (keys.hasNext()) {
            String lovItem = (String)keys.next();
            Object value = lovRow.getAttribute(lovItem);
            if (value instanceof ResultSet) {
                processResultSet((ResultSet)value);
            }
        }
    }

    public void copyMultiSelectReturnValues(RowKeySet rowKeySet, 
                                            JUIteratorBinding iterBinding) {
        Iterator it = rowKeySet.getKeySet().iterator();
        ViewObject vo = 
            iterBinding.getRowSetIterator().getRowSet().getViewObject();
        while (it.hasNext()) {
            Key key = (Key)it.next();
            Row[] rows = vo.findByKey(key, 1);
            if (rows != null && rows.length > 0) {
                // TODO Add check for table col model is null, which is the case when
                // LOV is invoked in form layout
                Row newRow = getTableCollectionModel().createNewRow(true);
                copyReturnValues(null, rows[0], newRow, false, false);
                // LJ: deal with nested records - any key/values of type ResultSet
                copyNestedReturnValues(rows[0]);
            }
        }
        // We need to reset table component tree, because otherwise some of the items
        // set on the newly created row are not immediately visible in the page when
        // returning from the LOV (bug??)
        getTableCollectionModel().refresh();
        JsfUtils.getInstance().resetComponentTree(getTableCollectionModel().getTable());
    }

    public void setNestedRecordAttributeMapping(String nestedRecordAttributeMapping) {
        this.nestedRecordAttributeMapping = nestedRecordAttributeMapping;
    }

    public String getNestedRecordAttributeMapping() {
        return nestedRecordAttributeMapping;
    }
}
